
' DesktopWeatherXML by Badboy (badboyKU@hotmail.com)
' v 1.0 - Initial Version.
' v 1.1 - Added a set of images called old (which come from DesktopWeather v0.41).
' v 1.2 - Fixed some small bugs, added better restart feature (no more extra icons).
' v 1.3 - Removed restart feature, due to Samurize 1.0.1 refreshes images instantly they change and provided a new sample config.

'-------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------
' >> Deutsche berarbeitung von Gumfuzi <<
'                            http://www.desk-modder.de (DIE deutsche DeskModding-Community!)
'                                   WWW.DESK-MODDER.DE - STYLING IS EVERYTHING !!
' Support gibt es hier: http://web1.152250.vserver.de/phpBB2/viewforum.php?f=27
'-------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------
' Version 1.3.D1.0
' Version 1.3.D1.1 vom 03.01.2004 deutsche Monate, deutsche Uhrzeiten
' Version 1.3.D1.2 vom 12.01.2004 weitere getCondition eingedeutscht
' Version 1.3.D1.3 vom 15.01.2004 Monat & Tag nun korrekt bei getLastUpdate
' Version 1.3.D1.4 vom 20.03.2004 neue deutsche Begriffe bei der Wetterlage
' Version 1.3.D1.5 vom 06.06.2004 UV-Index nun auch in deutsch + Wetterlagen korrigiert


'-------------------------------------------------------------------------------------------
' CREDITS
'-------------------------------------------------------------------------------------------
' Thanks goes out to Judge (samurize@jools.net) for his work on DesktopWeather v0.41. A lot
' of credit goes out to his original piece of work.


'-------------------------------------------------------------------------------------------
' Anleitung:
'-------------------------------------------------------------------------------------------
' Zuerst gehe zu: http://xoap.weather.com/search/search?where=XXXXX
' Das "XXXXX" in der URL ist durch Deine Stadt zu ersetzen (BEVOR Du die URL dann aufrufst)
' Danach sollte eine Seite kommen mit "loc id". Dieser Code mu weiter unten in diesem Skript
' eingefgt werden. Die "loc id" legt fest, fr welche Stadt das Wetter ausgelesen wird.
' Danach einfach die nachstehenden Konstanten anpassen
' Wichtig beim Erstellen der Config: ZUERST eine Anzeige mit der Funktion "getCacheFiles" von
' diesen Skript erstellen, damit alle Daten richtig von der Wetterseite gelesen werden.
' Die passenden Icons (falls nicht dabei) gibt es auch auf www.desk-modder.de

'-------------------------------------------------------------------------------------------
' KONSTANTEN - Diese bitte an Deine persnlichen Zwecke anpassen!
'-------------------------------------------------------------------------------------------
const LOCID  = "AUXX0016" ' Hier den Code ("loc id") Deiner Stadt angeben (siehe oben)
const UNIT   = "m"     ' Ma-Einheiten (m="C"; s="F)
const DAYF   = "8"     ' Anzahl der Tage fr die Vorhersage (von 1-10 Tage mglich)
const IMAGES = "old"   ' alte oder neue PNGs ("old" oder "new") - ist Geschmacksache
' die PNG's mssen normalerweise hier rein: C:\Programme\Samurize\Skins\DesktopWeatherXML\images\old
const SAMURIZE_DIRECTORY = "C:\Programme\Samurize" ' Pfad zum Samurize(Programm)


'-------------------------------------------------------------------------------------------
' ab hier ist der Code - bitte nichts verndern, auer Du weit, was Du tust!
'-------------------------------------------------------------------------------------------
'  The reason for 2 files is because weather.com has some restrictions on how many times
'  you contact the server in a set time. If you hammer the server too many times, you
'  will be blocked from the server for a small time (usually 30 minutes).
'-------------------------------------------------------------------------------------------
dim x30minURL, x30minFile, x120minURL, x120minFile
Randomize
x30minURL = "http://xoap.weather.com/weather/local/" & LOCID & "?cc=*" & "&par=" & Int(Rnd * 10000) & "&prod=xoap&key=" & Int(Rnd * 10000) & "&unit=" & UNIT
x30minFile = SAMURIZE_DIRECTORY & "\Scripts\DesktopWeather30min.xml"
x120minURL = "http://xoap.weather.com/weather/local/" & LOCID & "?cc=*&dayf=" & DAYF & "&par=" & Int(Rnd * 10000) & "&prod=xoap&key=" & Int(Rnd * 10000) & "&unit=" & UNIT
x120minFile = SAMURIZE_DIRECTORY & "\Scripts\DesktopWeather120min.xml"


'-------------------------------------------------------------------------------------------
' Misc Functions
'-------------------------------------------------------------------------------------------
Function validDayNum(dayNum)
  If (CInt(dayNum) > -1) AND (CInt(dayNum) < CInt(DAYF)) Then
    validDayNum = TRUE
  Else
    validDayNum = FALSE
  End If
End Function
Function abbrevDayName(dayName)
  If dayName = "Sunday" Then
    abbrevDayName = "SO"
  ElseIf dayName = "Monday" Then
    abbrevDayName = "MO"
  ElseIf dayName = "Tuesday" Then
    abbrevDayName = "DI"
  ElseIf dayName = "Wednesday" Then
    abbrevDayName = "MI"
  ElseIf dayName = "Thursday" Then
    abbrevDayName = "DO"
  ElseIf dayName = "Friday" Then
    abbrevDayName = "FR"
  ElseIf dayName = "Saturday" Then
    abbrevDayName = "SA"
  Else
    abbrevDayName = "NA"
  End If
End Function
Function copyImage(imageName, tempImageName)
  Dim fso
  copyImage = FALSE
  Set fso = CreateObject("Scripting.FileSystemObject")
  If fso.FileExists(SAMURIZE_DIRECTORY & "\Skins\DesktopWeatherXML" & imageName) Then
    fso.CopyFile SAMURIZE_DIRECTORY & "\Skins\DesktopWeatherXML" & imageName, SAMURIZE_DIRECTORY & "\Skins\DesktopWeatherXML\temp\" & tempImageName, TRUE
    copyImage = TRUE
  End If
  Set fso = Nothing
End Function
Function getImage(num)
  If num=0 OR num=3 OR num=4 OR num=17 OR num=35 Then ' Thunderstorms
    getImage = "0"
  ElseIf num=1 OR num=2 Then ' Windy Rain
    getImage = "1"
  ElseIf num=5 Then ' Snow/Rain Mix
    getImage = "5"
  ElseIf num=6 OR num=18 Then ' Hail
    getImage = "6"
  ElseIf num=7 Then ' Snow/Rain Icy Mix
    getImage = "7"
  ElseIf num=8 Then ' Light Rain Icy
    getImage = "8"
  ElseIf num=9 Then ' Light Rain
    getImage = "9"
  ElseIf num=10 Then ' Heavy Rain Icy
    getImage = "10"
  ElseIf num=11 Then ' Rain
    getImage = "11"
  ElseIf num=12 OR num=39 OR num=40 Then ' Heavy Rain
    getImage = "12"
  ElseIf num=13 Then ' Light Snow
    getImage = "13"
  ElseIf num=14 Then ' Snow
    getImage = "14"
  ElseIf num=15 Then ' Snowflakes
    getImage = "15"
  ElseIf num=16 OR num=41 OR num=42 Then ' Heavy Snow
    getImage = "16"
  ElseIf num=19 Then ' Dust
    getImage = "19"
  ElseIf num=20 Then ' Fog
    getImage = "20"
  ElseIf num=21 Then ' Haze
    getImage = "21"
  ElseIf num=22 Then ' Smoke
    getImage = "22"
  ElseIf num=23 OR num=24 Then ' Windy
    getImage = "23"
  ElseIf num=25 Then ' Frigid
    getImage = "25"
  ElseIf num=26 Then ' Cloudy
    getImage = "26"
  ElseIf num=27 Then ' Mostly Cloudy Night
    getImage = "27"
  ElseIf num=28 Then ' Mostly Cloudy Day
    getImage = "28"
  ElseIf num=29 Then ' Partly Cloudy Night
    getImage = "29"
  ElseIf num=30 OR num=44 Then ' Partly Cloudy Day
    getImage = "30"
  ElseIf num=31 OR num=33 Then ' Clear Night (moon)
    getImage = "31"
  ElseIf num=32 Then ' Sunny Day (sun)
    getImage = "32"
  ElseIf num=34 Then ' Light Partly Cloudy Day
    getImage = "34"
  ElseIf num=36 Then ' Hot Sunny Day
    getImage = "36"
  ElseIf num=37 OR num=38 Then ' Lightening
    getImage = "37"
  ElseIf num=43 Then ' Windy/Snowy
    getImage = "43"
  ElseIf num=45 Then ' Rainy Night
    getImage = "45"
  ElseIf num=46 Then ' Snowy Night
    getImage = "46"
  ElseIf num=47 Then ' Thunderstorms Night
    getImage = "47"
  Else
    getImage = "na" ' N/A
  End If
End Function


'-------------------------------------------------------------------------------------------
' 30 Min File Functions
'-------------------------------------------------------------------------------------------
Function getTempUnit()
  getTempUnit = "" & boundedString("<ut>", "</ut>", x30minFile)
End Function
Function getDistUnit()
  getDistUnit = boundedString("<ud>", "</ud>", x30minFile)
End Function
Function getSpeedUnit()
  getSpeedUnit = boundedString("<us>", "</us>", x30minFile)
End Function
Function getPrecipUnit()
  getPrecipUnit = boundedString("<up>", "</up>", x30minFile)
End Function
Function getPressureUnit()
  getPressureUnit = boundedString("<ur>", "</ur>", x30minFile)
End Function
Function getName()
  getName = boundedString("<dnam>", "</dnam>", x30minFile)
End Function
Function getTime()
  getTime = boundedString("<tm>", "</tm>", x30minFile)
  getTime = formatdatetime(getTime,vbShortTime)
End Function
Function getLatitude()
  getLatitude = boundedString("<lat>", "</lat>", x30minFile)
End Function
Function getLongitude()
  getLongitude = boundedString("<lon>", "</lon>", x30minFile)
End Function
Function getSunrise()
  getSunrise = boundedString("<sunr>", "</sunr>", x30minFile)
  getSunrise = formatdatetime(getSunrise,vbShortTime)
End Function
Function getSunset()
  getSunset = boundedString("<suns>", "</suns>", x30minFile)
  getSunset = formatdatetime(getSunset,vbShortTime)
End Function
Function getTimezone()
  getTimezone = boundedString("<zone>", "</zone>", x30minFile)
End Function
Function getLastUpdate()
  dim tag
  dim mon
  getLastUpdate = boundedString("<lsup>", "</lsup>", x30minFile)
  getLastUpdate = formatDateTime(left(getLastUpdate,15))
  getLastUpdate = left(getLastUpdate,16)
  mon = left(getLastUpdate,3)
  tag = mid(getLastUpdate,4,3)
  getLastUpdate = right(getLastUpdate,10)
  getLastUpdate = mon&tag&getLastUpdate&" lokale Zeit"
End Function
Function getObservedAt()
  getObservedAt = boundedString("<obst>", "</obst>", x30minFile)
End Function
Function getTemp()
  getTemp = boundedString("<tmp>", "</tmp>", x30minFile)
  If getTemp = "NA" OR getTemp = "N/A" Then
    getTemp = "NA"
  Else
    getTemp = getTemp & getTempUnit()
  End If
End Function
Function getFeelsLike()
  getFeelsLike = boundedString("<flik>", "</flik>", x30minFile)
  If getFeelsLike = "NA" OR getFeelsLike = "N/A" Then
    getFeelsLike = "NA"
  Else
    getFeelsLike = getFeelsLike & getTempUnit()
  End If
End Function
Function getCondition()
  getCondition = boundedString("<t>", "</t>", x30minFile)
  if getCondition="Windy Rain" Then getCondition="windiger Regen"
  if getCondition="Fog" then getCondition="Nebel"
  If getCondition="Rain / Snow Showers" Then getCondition="Schneeregen"
  If getCondition="Hail" Then getCondition="Hagel"
  If getCondition="Snow/Rain Icy Mix" Then getCondition="eisiger Schneeregen"
  If getCondition="Light Rain Icy" Then getCondition="leichter, eisiger Regen"
  If getCondition="Light Rain" Then getCondition="leichter Regen"
  If getCondition="Heavy Rain Icy" Then getCondition="starker, eisiger Regen"
  If getCondition="Rain" Then getCondition="Regen"
  If getCondition="Heavy Rain" Then getCondition="starker Regen"
  If getCondition="Light Snow" Then getCondition="leichter Schneefall"
  If getCondition="Snow" Then getCondition="Schneefall"
  If getCondition="Snowflakes" Then getCondition="Schneeflocken"
  If getCondition="Heavy Snow" Then getCondition="starker Schneefall"
  If getCondition="Dust" Then getCondition="Staub"
  If getCondition="Haze" Then getCondition="Dunst"
  If getCondition="Smoke" Then getCondition="Smog"
  If getCondition="Windy" Then getCondition="Windig"
  If getCondition="Frigid" Then getCondition="frostig"
  If getCondition="Cloudy" Then getCondition="wolkig"
  If getCondition="Mostly Cloudy" Then getCondition="wolkenbedeckt"
  If getCondition="Sunny Day" Then getCondition="sonnig"
  If getCondition="Lightening" Then getCondition="Gewitter"
  If getCondition="Windy/Snowy" Then getCondition="Schneesturm"
  If getCondition="Partly Cloudy" Then getCondition="teilweise bewlkt"
  If getCondition="Showers" Then getCondition="Regenschauer"
  If getCondition="Fair" Then getCondition="heiter"
  If getCondition="Mostly Sunny" Then getCondition="meist Sonnig"
  If getCondition="AM Clouds / PM Sun" Then getCondition="Vormittag wolkig / Nachmittag Sonne"
  If getCondition="Scattered Showers" Then getCondition="zeitweise Regenschauer"
  If getCondition="Few Showers" Then getCondition="vereinzelte Regenschauer"
  If getCondition="Snow Shower" Then getCondition="Schneeschauer"
  If getCondition="Scattered Snow Showers" Then getCondition="zeitweise Schneeschauer"
  If getCondition="Partly Cloudy / Wind" Then getCondition="teilweise bewlkt / Wind"
  If getCondition="Scattered Snow Showers / Wind" Then getCondition="zeitweise Schneeschauer / Wind"
  If getCondition="Showers / Wind" Then getCondition="Regenschauer / Wind"
  If getCondition="Few Snow Showers" Then getCondition="teilweise Schneeschauer"
  If getCondition="Sunny" Then getCondition="Sonnig"
  If getCondition="Few Snow Showers / Wind" Then getCondition="teilweise Schneeschauer / Wind"
  If getCondition="PM Showers" Then getCondition="nachmittags Regen"
  If getCondition="AM Showers" Then getCondition="vormittags Regen"
  If getCondition="T-Storms" Then getCondition="Gewitter"
  If getCondition="Scattered T-Storms" Then getCondition="zeitweise Gewitter"
  If getCondition="Isolated T-Storms" Then getCondition="vereinzelt Gewitter"
  If getCondition="PM Rain / Wind" Then getCondition="nachmittags Regen / Wind"
  If getCondition="Scattered Showers / Wind" Then getCondition="zeitweise Regen / Wind"
  If getCondition="AM Snow Showers" Then getCondition="vormittags Schneeschauer"
  If getCondition="PM Snow Showers" Then getCondition="nachmittags Schneeschauer"
  If getCondition="Mostly Clear" Then getCondition="berwiegend klar"
  If getCondition="Clear" Then getCondition="klar"
  If getCondition="Sunny / Wind" Then getCondition="sonnig / Wind"
  If getCondition="Rain / Snow Showers Early" Then getCondition="bald Regenschauer und Schneeschauer"
  If getCondition="Rain / Wind" Then getCondition="Regen / Wind"
  If getCondition="Light Rain Shower" Then getCondition="Leichter Regenschauer"
  If getCondition="Snow and Fog" Then getCondition="Schnee und Nebel"
  If getCondition="Few Snow Showers / Wind" Then getCondition="vereinzelt Schneeschauer mit Wind"
  If getCondition="Light Snow Fall" Then getCondition="leichte Schneeschauer"
  If getCondition="Wintry Mix" Then getCondition="Winter Mix"
  If getCondition="Cloudy / Wind" Then getCondition="bewlkt und windig"
  If getCondition="Drizzle" Then getCondition="Nieselregen"
  If getCondition="Light Drizzle" Then getCondition="leichter Nieselregen"
  If getCondition="Light Snow Shower" Then getCondition="leichter Schneefall"
  If getCondition="Showers in Vicinity" Then getCondition="Schauer in der Umgebung"
End Function

Function getConditionIcon()
  getConditionIcon = boundedString("<icon>", "</icon>", x30minFile)
End Function
Function getBarPressure()
  getBarPressure = boundedString3("<r>", "</r>", 1, boundedString("<bar>", "</bar>", x30minFile))
  If getBarPressure = "NA" OR getBarPressure = "N/A" Then
    getBarPressure = "NA"
  Else
    getBarPressure = getBarPressure & " hPa"
  End If
End Function
Function getBarPressureDir()
  getBarPressureDir = boundedString3("<d>", "</d>", 1, boundedString("<bar>", "</bar>", x30minFile))
  If getBarPressureDir = "rising" Then
    getBarPressureDir = "h"
  ElseIf getBarPressureDir = "falling" Then
    getBarPressureDir = "i"
  Else 'steady
    getBarPressureDir = ""
  End If
End Function
Function getWindSpeed()
  getWindSpeed = boundedString3("<s>", "</s>", 1, boundedString("<wind>", "</wind>", x30minFile))
  If getWindSpeed = "NA" OR getWindSpeed = "N/A" Then
    getWindSpeed = "NA "
  ElseIf getWindSpeed <> "calm" Then
    getWindSpeed = getWindSpeed & " " & getSpeedUnit()
  Elseif getWindspeed = "calm" then
    getwindspeed="Windstill"
  End If
End Function
Function getWindDegree()
  getWindDegree = boundedString3("<d>", "</d>", 1, boundedString("<wind>", "</wind>", x30minFile))
End Function
Function getHumidity()
  getHumidity = boundedString("<hmid>", "</hmid>", x30minFile)
  If getHumidity = "NA" OR getHumidity = "N/A" Then
    getHumidity = "NA"
  Else
    getHumidity = getHumidity & "%"
  End If
End Function
Function getVisibility()
  getVisibility = boundedString("<vis>", "</vis>", x30minFile)
  If getVisibility = "NA" OR getVisibility = "N/A" Then
    getVisibility = "NA"
  ElseIf getVisibility <> "Unlimited" Then
    getVisibility = getVisibility & " " & getDistUnit()
  ElseIf getVisibility = "Unlimited" Then
    getVisibility = "unendlich"
  End If
End Function
Function getUVindex()
  getUVindex = boundedString3("<i>", "</i>", 1, boundedString("<uv>", "</uv>", x30minFile))
  If getUVindex = "0" then getUVindex = "0 minimal"
  If getUVindex = "1" then getUVindex = "1 sehr schwach"
  If getUVindex = "2" then getUVindex = "2 sehr schwach"
  If getUVindex = "3" then getUVindex = "3 schwach"
  If getUVindex = "4" then getUVindex = "4 schwach"
  If getUVindex = "5" then getUVindex = "5 mittel"
  If getUVindex = "6" then getUVindex = "6 mittel"
  If getUVindex = "7" then getUVindex = "7 hoch!"
  If getUVindex = "8" then getUVindex = "8 hoch!"
  If getUVindex = "9" then getUVindex = "9 hoch!"
  If getUVindex = "10" then getUVindex = "10 sehr hoch!!!"
  If getUVindex = "11" then getUVindex = "11 sehr hoch!!!"
  If getUVindex = "12" then getUVindex = "12 sehr hoch!!!"
  If getUVindex = "NA" OR getUVindex = "N/A" Then
    getUVindex = "NA"
  Else
    getUVindex = getUVindex & " " & getUVindexText()
  End If
End Function
Function getUVindexText()
  getUVindexText = ""'boundedString3("<t>", "</t>", 1, boundedString("<uv>", "</uv>", x30minFile))
End Function
Function getDewPoint()
  getDewPoint = boundedString("<dewp>", "</dewp>", x30minFile)
  If getDewPoint = "NA" OR getDewPoint = "N/A" Then
    getDewPoint = "NA"
  Else
    getDewPoint = getDewPoint & getTempUnit()
  End If
End Function


'-------------------------------------------------------------------------------------------
' 120 Min File Functions
'-------------------------------------------------------------------------------------------
Function getDayName(dayNum) 'dayNum values [0...9]
  If validDayNum(dayNum) Then
    If CInt(dayNum) = 0 Then
      If getDayHigh(dayNum) = "NA" Then
        getDayName = "NA"
      ElseIf getDayHigh(dayNum) = "N/A" Then 'its tonight
        getDayName = "NACHT"
      Else 'its today
        getDayName = "TAG"
      End If
    Else
      getDayName = abbrevDayName(boundedString("<day d=" & Chr(34) & dayNum & Chr(34) & " t=" & Chr(34), Chr(34), x120minFile))
    End If
  Else
    getDayName = "NA"
  End If
End Function
Function getDayDate(dayNum) 'dayNum values [0...9]
dim mon
dim tag
  If validDayNum(dayNum) Then
    getDayDate = boundedString3("dt=" & Chr(34), Chr(34), 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile))
    mon = left(getDayDate,3)
    tag = right(getdayDate,(len(getDayDate)-4))
    if mon = "Jan" then mon = ". Jn"
    if mon = "Feb" then mon = ". Feb"
    if mon = "Mar" then mon = ". Mr"
    if mon = "Apr" then mon = ". Apr"
    if mon = "May" then mon = ". Mai"
    if mon = "Jun" then mon = ". Jun"
    if mon = "Jul" then mon = ". Jul"
    if mon = "Aug" then mon = ". Aug"
    if mon = "Sep" then mon = ". Sep"
    if mon = "Oct" then mon = ". Okt"
    if mon = "Nov" then mon = ". Nov"
    if mon = "Dec" then mon = ". Dez"
    getDayDate = tag & mon
  Else
    getDayDate = "NA"
  End If
End Function
Function getDayHigh(dayNum) 'dayNum values [0...9]
  If validDayNum(dayNum) Then
    getDayHigh = boundedString3("<hi>", "</hi>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile))
  Else
    getDayHigh = "NA"
  End If
End Function
Function getDayLow(dayNum) 'dayNum values [0...9]
  If validDayNum(dayNum) Then
    getDayLow = boundedString3("<low>", "</low>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile))
  Else
    getDayLow = "NA"
  End If
End Function
Function getDayHighLow(dayNum) 'dayNum values [0...9]
  Dim high, low
  If validDayNum(dayNum) Then
    high = getDayHigh(dayNum)
    low = getDayLow(dayNum)
    If high = "NA" Then
      getDayHighLow = "NA"
    ElseIf high = "N/A" Then
      getDayHighLow = low & ""
    Else
      getDayHighLow = high & "" & "/ " & low & ""
    End If
  Else
    getDayHighLow = "NA"
  End If
End Function
Function getDaySunrise(dayNum) 'dayNum values [0...9]
  getDaySunrise = boundedString3("<sunr>", "</sunr>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile))
  getDaySunrise = formatdatetime(getDaySunrise,vbShortTime)
End Function
Function getDaySunset(dayNum) 'dayNum values [0...9]
  getDaySunset = boundedString3("<suns>", "</suns>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile))
  getDaySunset = formatdatetime(getDaySunset,vbShortTime)
End Function
Function getDayIcon(dayNum) 'dayNum values [0...9]
  If getDayHigh(dayNum) = "N/A" Then 'get icon for night
    getDayIcon = boundedString3("<icon>", "</icon>", 1, boundedString3("<part p=" & Chr(34) & "n" & Chr(34) & ">", "</part>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile)))
  Else 'get icon for day
    getDayIcon = boundedString3("<icon>", "</icon>", 1, boundedString3("<part p=" & Chr(34) & "d" & Chr(34) & ">", "</part>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile)))
  End If
End Function
Function getDayPrecip(dayNum) 'dayNum values [0...9]
  If getDayHigh(dayNum) = "N/A" Then 'get precip percentage for night
    getDayPrecip = boundedString3("<ppcp>", "</ppcp>", 1, boundedString3("<part p=" & Chr(34) & "n" & Chr(34) & ">", "</part>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile)))
    If getDayPrecip = "NA" Then
      getDayPrecip = "NA"
    Else
      getDayPrecip = getDayPrecip & "%"
    End If
  Else 'get precip percentage for day
    getDayPrecip = boundedString3("<ppcp>", "</ppcp>", 1, boundedString3("<part p=" & Chr(34) & "d" & Chr(34) & ">", "</part>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile)))
    If getDayPrecip = "NA" Then
      getDayPrecip = "NA"
    Else
      getDayPrecip = getDayPrecip & "%"
    End If
  End If
End Function
Function getDayHumidity(dayNum) 'dayNum values [0...9]
  If getDayHigh(dayNum) = "N/A" Then 'get humidity for night
    getDayHumidity = boundedString3("<hmid>", "</hmid>", 1, boundedString3("<part p=" & Chr(34) & "n" & Chr(34) & ">", "</part>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile)))
    If getDayHumidity = "NA" Then
      getDayHumidity = "NA"
    Else
      getDayHumidity = getDayHumidity & "%"
    End If
  Else 'get humidity for day
    getDayHumidity = boundedString3("<hmid>", "</hmid>", 1, boundedString3("<part p=" & Chr(34) & "d" & Chr(34) & ">", "</part>", 1, boundedString("<day d=" & Chr(34) & dayNum & Chr(34), "</day>", x120minFile)))
    If getDayHumidity = "NA" Then
      getDayHumidity = "NA"
    Else
      getDayHumidity = getDayHumidity & "%"
    End If
  End If
End Function



'-------------------------------------------------------------------------------------------
' Get File Functions
'-------------------------------------------------------------------------------------------
Function getCacheFiles()
  On Error Resume Next
  Dim file1, file2, mins, copy
  mins = 5 ' Do not change time or you will be blocked by weather.com server!
  file1 = getCacheFile(mins, x30minURL, x30minFile)
  mins = 10 ' Do not change time or you will be blocked by weather.com server!
  file2 = getCacheFile(mins, x120minURL, x120minFile)
  If file1 Then
    copy = copyImage("\images\" & IMAGES & "\" & getImage(getConditionIcon()) & ".png", "now.png")
  End If
  If file2 Then
    For i = 0 To (DAYF-1)
      copy =  copyImage("\images\" & IMAGES & "\" & getImage(getDayIcon(i)) & ".png", "day" & i & ".png")
    Next
  End If
End Function
Function getCacheFile(mins, fileURL, filename)
  Dim oldFile, fs
  Set fs = CreateObject("Scripting.FileSystemObject")
  If (Not fs.FileExists(filename)) Then
    oldFile = True
  Else
    Set cacheFile = fs.GetFile(filename)
    oldFile = False
    If CInt(DateDiff("n", cacheFile.DateLastModified, Now())) >= CInt(mins) Then
      oldFile = True
    End If
  End If
  If oldFile Then
    Dim Http, HtmlResult, f
    Set Http = CreateObject("Microsoft.XMLhttp")
    Http.Open "GET", fileURL, False
    Http.Send
    HtmlResult = Http.ResponseText
    Set Http = Nothing
    Set f = fs.CreateTextFile(filename, true, true)
    f.write(HtmlResult)
    f.close
    Set f = nothing
  End If
  Set fs = nothing
  getCacheFile = oldFile
End Function


'-------------------------------------------------------------------------------------------
' String Extraction Functions
'-------------------------------------------------------------------------------------------
Function boundedString(LeftBound, RightBound, fileName)
  boundedString = boundedString2(LeftBound, RightBound, 1, fileName)
End Function
Function boundedString2(LeftBound, RightBound, count, fileName)
  Dim xmlResult
  Set file_obj = CreateObject("Scripting.FileSystemObject")
  If (file_obj.FileExists(fileName)) Then
    Set file_path = file_obj.GetFile(fileName) ' Creates the connection to the file
    Set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading
    xmlResult = file.readall
    File.Close ' Closes the file
    Set file_path = nothing ' Resets variable
    Set file_obj = nothing ' Resets variable
    boundedString2 = boundedString3(LeftBound, RightBound, count, xmlResult)
  Else
    boundedString2 = "NA"
  End If
End Function
Function boundedString3(LeftBound, RightBound, count, xmlResult)
  Dim xmlStart, xmlEnd
  xmlStart = InStr(1, xmlResult, LeftBound, 1) + Len(LeftBound)
  xmlEnd = InStr(xmlStart, xmlResult, RightBound, 1)
  For counter = 2 To count
    xmlStart = InStr(xmlEnd + Len(RightBound), xmlResult, LeftBound, 1) + Len(LeftBound) 
    xmlEnd = InStr(xmlStart, xmlResult, RightBound, 1)
  Next
  If xmlStart > 0 AND xmlEnd > 0 Then
    boundedString3 = Mid(xmlResult, xmlStart, xmlEnd - xmlStart)
  Else
    boundedString3 = "NA"
  End If
End Function
